﻿using Syncfusion.GroupingGridExcelConverter;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.XlsIO;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ExportToExcel
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            //Set the DataSource for GridGroupingControl
            this.gridGroupingControl1.DataSource = GetTheGridTable();

            //Set the CellValueType for particular column which is want to be exported as Numeric
           // this.gridGroupingControl1.TableDescriptor.Columns["Rate"].Appearance.AnyRecordFieldCell.CellValueType = typeof(double);
            this.gridGroupingControl1.Appearance.AnyRecordFieldCell.Format = "#0.00";
            
            

        }

        private DataTable GetTheGridTable()
        {
            string[] fruits = { "apple", "banana", "pineapple", "orange", "papaya" };
            DataTable dt = new DataTable("Orders");

            int nCols = 2;
            int nRows = 5;
            dt.Columns.Add("Rate", typeof(double));
            dt.Columns.Add("AssessableValue", typeof(double));

            Random r = new Random();
            for (int i = 0; i < nRows; i++)
            {
                DataRow dr = dt.NewRow();
                for (int j = 0; j < nCols; j++)
                {
                    dr[j] = 2.00;
                }
                dt.Rows.Add(dr);
            }
            return dt;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            
            
            
            
            

            
            
            
            
            
            
            GroupingGridExcelConverterControl converter = new GroupingGridExcelConverterControl();            
            ExcelEngine excelEngine = new ExcelEngine();
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.Filter = "Files(*.xls)|*.xlx";
            openFileDialog.DefaultExt = ".xls";            
            
            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                //Create the object for the WorkBook
                IWorkbook sourceWorkBook = excelEngine.Excel.Workbooks.Open(openFileDialog.FileName);
                //Create temp worksheet for converting the grid to excel.
                sourceWorkBook.Worksheets.Create("Dummy");
                //Export grid to the temp worksheet
                converter.GroupingGridToExcel(this.gridGroupingControl1, sourceWorkBook.Worksheets["Dummy"], Syncfusion.GridExcelConverter.ConverterOptions.Default);
               //Get the used range of temp worksheet
                IRange currenRange = sourceWorkBook.Worksheets["Dummy"].UsedRange;   
                //get the used range of Primary worksheet
                IRange excelRange = sourceWorkBook.Worksheets[0].UsedRange;
                //Move the used range of temp worksheet to the end of the used range of primary worksheet
                currenRange.MoveTo(sourceWorkBook.Worksheets[0][excelRange.Rows.Length+1,1]);
        }       //Remove the temp worksheet from the workbook.
    }           sourceWorkBook.Worksheets["Dummy"].Remove();
}               //Save the changes in the workbook
                sourceWorkBook.Save();
                if (MessageBox.Show("Do you wish to open the xls file now?", "Export to Excel", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                {
                    Process proc = new Process();
                    proc.StartInfo.FileName = openFileDialog.FileName;
                    proc.Start();
                }              
            }